"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const t = __importStar(require("io-ts"));
const Config = t.exact(t.partial({
    android: t.exact(t.interface({
        icon: t.string,
        outputDir: t.string,
    })),
    assets: t.exact(t.interface({
        inputDir: t.string,
        outputDir: t.union([t.undefined, t.string]),
    })),
    ios: t.exact(t.interface({
        icon: t.string,
        outputDir: t.string,
    })),
}));
function decodeConfig(input) {
    const result = Config.decode(input);
    if (result.isLeft()) {
        throw new Error(`Invalid config: ${result.value.map(renderValidationError).join('\n')}`);
    }
    return result.value;
}
exports.decodeConfig = decodeConfig;
function renderValidationError(error) {
    const errorPath = error.context
        .map(contextEntry => contextEntry.key)
        .filter(key => key.length > 0)
        .join('.');
    const errorContext = error.context[error.context.length - 1];
    return `Expected ${errorContext.type.name} at ${errorPath}, got ${JSON.stringify(error.value)}`;
}
